Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* Axcpi01w.bas
'*
'* AXC-PI01
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date Jun.2003
'* Date Sep.2004	Axcpi01wInPortW() ̈(^)C
'*					Axcpi01wOutPortW()̈(^)C
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "Coredll.dll" Alias "LoadLibraryW" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "Coredll.dll" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "Coredll.dll" Alias "GetProcAddressW" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Dim hDLL As Long                               ' DLLւ̃nh
Public Const AXCPI01_DLL_NAME = "Axcpi01w.dll" ' DLL
Public Const AXCPI01_ERR_WRAPDLL = -1          ' bp[֐G[

'*****************************************************************************
'*    Axcpi01.dll[h
'*    
'* ߂l  True
'*        s False
'*****************************************************************************
 Public Function Axcpi01wDllOpen() As Boolean
    Dim s As String
    
    s = "Axcpi01w.dll" & vbNullChar
    
    Axcpi01wDllOpen = False
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(s)
    If hDLL = 0 Then Exit Function
    If Axcpi01wGetDllExportFunc() = False Then
        MsgBox "ExportFunc ERR"
        Axcpi01wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    Axcpi01wDllOpen = True
End Function


'*****************************************************************************
'*    Axcpi01.dllA[h
'*    
'* ߂l  True
'*        s False
'*****************************************************************************
Public Function Axcpi01wDllClose() As Boolean
    Axcpi01wDllClose = True
    If hDLL = 0 Then Exit Function
    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Axcpi01wDllClose = False
End Function

'*****************************************************************************
'*    AXC-PI01 DLL,Driver̃o[Wԍ擾
'*    pdwDllVer  DLLo[Wԍi[
'*        pdwDrvVer  Drivero[Wԍi[
'* ߂l  True
'*        s False
'*****************************************************************************
Public Function Axcpi01wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean
    Axcpi01wGetVersion = False
    If hDLL = 0 Then Exit Function
    If Axcpi01GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
    Axcpi01wGetVersion = True
End Function

'*****************************************************************************
'*    AXC-PI01̔Cӂ̃foCX̎gp錾
'*    pwLogSocket gpfoCXi[AhX
'*        hWnd        bZ[W𑗂EBhEnh
'*        uWMBase     ƂȂ郁bZ[WID
'*        pvInitArg   gp(0Zbg)
'* ߂l  True
'*        s False
'*****************************************************************************
Public Function Axcpi01wCreate(ByRef pwLogSocket As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean
    Axcpi01wCreate = False
    If hDLL = 0 Then Exit Function
    If Axcpi01Create(pwLogSocket, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function
    Axcpi01wCreate = True
End Function

'*****************************************************************************
'*    AXC-PI01̔Cӂ̃foCX̎gpJ
'*    wLogSocket gpfoCX
'* ߂l  True
'*        s False
'*****************************************************************************
Public Function Axcpi01wClose(ByVal wLogSocket As Integer) As Boolean
    Axcpi01wClose = False
    If hDLL = 0 Then Exit Function
    If Axcpi01Close(wLogSocket) = 0 Then Exit Function
    Axcpi01wClose = True
End Function

'*****************************************************************************
'*    wfoCX̃\[X擾
'*    wLogSocket @@@ 擾foCX
'*        pdwIOPortBase    I/Ox[XAhXi[
'*        pdwIOPortLength  I/Ox[Xi[
'* ߂l  True
'*        s False
'*****************************************************************************
Function Axcpi01wGetResource(ByVal wLogSocket As Integer, ByRef pdwIOPortBase As Long, _
                                                       ByRef pdwIOPortLength As Long _
                                                       ) As Boolean
    Axcpi01wGetResource = False
    If hDLL = 0 Then Exit Function
    If Axcpi01GetResource(wLogSocket, pdwIOPortBase, pdwIOPortLength) = 0 Then Exit Function
    Axcpi01wGetResource = True
End Function

'*****************************************************************************
'*    oCg
'*    wLogSocket  擾foCX
'*        dwPort      ̓|[gԍ
'*        bpValue     ͒li[
'* ߂l  True
'*        s False
'*****************************************************************************
Function Axcpi01wInPortB(ByVal wLogSocket As Integer, ByVal dwPort As Long, ByRef pbValue As Byte) As Boolean
    Axcpi01wInPortB = False
    If hDLL = 0 Then Exit Function
    If Axcpi01InPortB(wLogSocket, dwPort, pbValue) = 0 Then Exit Function
    Axcpi01wInPortB = True
End Function

'*****************************************************************************
'*    oCgo
'*    wLogSocket  擾foCX
'*        dwPort      o̓|[gԍ
'*        wValue      o͂l
'* ߂l  True
'*        s False
'*****************************************************************************
Function Axcpi01wOutPortB(ByVal wLogSocket As Integer, ByVal dwPort As Long, ByVal bValue As Byte) As Boolean
    Axcpi01wOutPortB = False
    If hDLL = 0 Then Exit Function
    If Axcpi01OutPortB(wLogSocket, dwPort, bValue) = 0 Then Exit Function
    Axcpi01wOutPortB = True
End Function

'*****************************************************************************
'*    [h
'*    wLogSocket  擾foCX
'*        dwPort      ̓|[gԍ
'*        pwValue     ͒li[
'* ߂l  True
'*        s False
'*****************************************************************************
Function Axcpi01wInPortW(ByVal wLogSocket As Integer, ByVal dwPort As Long, ByRef pwValue As Integer) As Boolean
    Axcpi01wInPortW = False
    If hDLL = 0 Then Exit Function
    If Axcpi01InPortW(wLogSocket, dwPort, pwValue) = 0 Then Exit Function
    Axcpi01wInPortW = True
End Function


'*****************************************************************************
'*    [ho
'*    wLogSocket  擾foCX
'*        dwPort      o̓|[gԍ
'*        wValue      o͂l
'* ߂l  True
'*        s False
'*****************************************************************************
Function Axcpi01wOutPortW(ByVal wLogSocket As Integer, ByVal dwPort As Long, ByVal wValue As Integer) As Boolean
    Axcpi01wOutPortW = False
    If hDLL = 0 Then Exit Function
    If Axcpi01OutPortW(wLogSocket, dwPort, wValue) = 0 Then Exit Function
    Axcpi01wOutPortW = True
End Function


'*****************************************************************************
'*    wfoCX̊荞݃Xe[^X擾
'*    wLogSocket   擾foCX
'*        pbStatus     荞݃Xe[^Xi[
'* ߂l  True
'*        s False
'*****************************************************************************
Function Axcpi01wGetIRQStatus(ByVal wLogSocket As Integer, ByRef pbStatus As Byte) As Boolean
    Axcpi01wGetIRQStatus = False
    If hDLL = 0 Then Exit Function
    If Axcpi01GetIRQStatus(wLogSocket, pbStatus) = 0 Then Exit Function
    Axcpi01wGetIRQStatus = True
End Function


'*****************************************************************************
'*    AXC-PI01̃G[R[h
'*    wLogSocket  G[foCX
'* ߂l G[R[h
'*****************************************************************************
Function Axcpi01wGetLastError(ByVal wLogSocket As Integer) As Long
    Axcpi01wGetLastError = AXCPI01_ERR_WRAPDLL
    If hDLL = 0 Then Exit Function
    Axcpi01wGetLastError = Axcpi01GetLastError(wLogSocket)
End Function
'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF
'*    
'* ߂l  True
'*        s False
'*---------------------------------------------------------------------------*
Private Function Axcpi01wGetDllExportFunc() As Boolean
    Dim pFunc As Long

    Axcpi01wGetDllExportFunc = False

    ' Axcpi01GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01GetVersion")
    If pFunc = 0 Then Exit Function

    ' Axcpi01Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01Create")
    If pFunc = 0 Then Exit Function

    ' Axcpi01Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01Close")
    If pFunc = 0 Then Exit Function

    ' Axcpi01GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01GetResource")
    If pFunc = 0 Then Exit Function
    
    ' Axcpi01InPortB ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01InPortB")
    If pFunc = 0 Then Exit Function

    ' Axcpi01OutPortB ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01OutPortB")
    If pFunc = 0 Then Exit Function

    ' Axcpi01InPortW ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01InPortW")
    If pFunc = 0 Then Exit Function

    ' Axcpi01OutPortW ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01OutPortW")
    If pFunc = 0 Then Exit Function

    ' Axcpi01GetIRQStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01GetIRQStatus")
    If pFunc = 0 Then Exit Function

    ' Axcpi01GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Axcpi01GetLastError")

    If pFunc = 0 Then Exit Function

    Axcpi01wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
