// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "AXCPI01App.h"
#include "typedef.h"

#include "MainFrm.h"
#include "AXCPI01Doc.h"
#include "OutputEnDlg.h"
#include "OutputSelDlg.h"
#include "PUDCtrlDlg.h"
#include "IRQSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// z tbSTDButton ɂ͓K؂ȃrbg}bv IDB_STD_SMALL_COLOR ̃{^܂܂Ă܂B
static TBBUTTON tbButtons[] = {
	{0, 0,				TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0,  0},  
	{0,	ID_FILE_NEW,	TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, -1},
	{1, ID_FILE_OPEN,	TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, -1},
	{2, ID_FILE_SAVE,	TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, -1},
	{0, 0,				TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, -1},
	{3, ID_EDIT_CUT,	TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, -1},
	{4, ID_EDIT_COPY,	TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, -1},
	{5, ID_EDIT_PASTE,	TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, -1},
	{0, 0,				TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, -1},
	{6, ID_APP_ABOUT,	TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0, -1},
	{0, 0,				TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0,  0}
};
const int nNumButtons = sizeof(tbButtons)/sizeof(TBBUTTON);
const int nNumImages = 7;
const DWORD dwAdornmentFlags = 0; // I{^

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(IDM_SEL_IRQ, OnUpdateSelIrq)
	ON_COMMAND(IDM_SEL_IRQ, OnSelIrq)
	ON_UPDATE_COMMAND_UI(IDM_SEL_OUTPUT_EN, OnUpdateSelOutputEn)
	ON_COMMAND(IDM_SEL_OUTPUT_EN, OnSelOutputEn)
	ON_UPDATE_COMMAND_UI(IDM_SEL_OUTPUT, OnUpdateSelOutput)
	ON_COMMAND(IDM_SEL_OUTPUT, OnSelOutput)
	ON_UPDATE_COMMAND_UI(IDM_SEL_PUPD_CTRL, OnUpdateSelPupdCtrl)
	ON_COMMAND(IDM_SEL_PUPD_CTRL, OnSelPupdCtrl)
	ON_UPDATE_COMMAND_UI(IDM_DISP_INPUT, OnUpdateDispInput)
	ON_COMMAND(IDM_DISP_INPUT, OnDispInput)
	ON_UPDATE_COMMAND_UI(IDM_DISP_INT, OnUpdateDispInt)
	ON_COMMAND(IDM_DISP_INT, OnDispInt)
	ON_UPDATE_COMMAND_UI(IDM_DISP_ERROR, OnUpdateDispError)
	ON_COMMAND(IDM_DISP_ERROR, OnDispError)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

//***********************************************************************
//	֐F׽̍\z
//	֐@FCMainFrame
//***********************************************************************
CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	
}

//***********************************************************************
//	֐F׽̔j
//	֐@F~CMainFrame
//***********************************************************************
CMainFrame::~CMainFrame()
{
}

//***********************************************************************
//	֐FWindow ̍\z
//	֐@FOnCreate
//		F	LPCREATESTRUCT&	lpCreateStruct		CREATESTRUCTNX|C^
//***********************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// R}h o[Ƀ{^ƃANZTǉĂB
	if (/*!InsertButtons(tbButtons, nNumButtons, IDR_MAINFRAME, nNumImages) ||*/
	    !AddAdornments(dwAdornmentFlags))
	{
		TRACE0("Failed to add toolbar buttons\n");
		return -1;
	}

	return 0;
}

//***********************************************************************
//	֐FWindow ̍\z
//	֐@FPreCreateWindow
//		F	CREATESTRUCT&	cs		CREATESTRUCTNX|C^
//***********************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs CāA Window NX
	//            X^CCĂB


	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

//***********************************************************************
//	֐Fj["IRQ Register" \
//	֐@FOnUpdateSelIrq
//		F	CCmdUI*		pCmdUI	CCmdUINX̃|C^
//***********************************************************************
void CMainFrame::OnUpdateSelIrq(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
}

//***********************************************************************
//	֐Fj["IRQ Register" 
//	֐@FOnSelIrq
//***********************************************************************
void CMainFrame::OnSelIrq() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CIRQSetDlg*		pDlg;
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();
	
	pDlg	= new CIRQSetDlg(pDoc);
	
	if(pDlg->DoModal() == IDOK)
	{
	}
	
	delete	pDlg;
}

//***********************************************************************
//	֐Fj["I/O Select Register" \
//	֐@FOnUpdateSelOutputEn
//		F	CCmdUI*		pCmdUI	CCmdUINX̃|C^
//***********************************************************************
void CMainFrame::OnUpdateSelOutputEn(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
}

//***********************************************************************
//	֐Fj["I/O Select Register" 
//	֐@FOnSelOutputEn
//***********************************************************************
void CMainFrame::OnSelOutputEn() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	COutputEnDlg*	pDlg;
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();
	
	pDlg	= new COutputEnDlg(pDoc);
	
	if(pDlg->DoModal() == IDOK)
	{
	}
	
	delete	pDlg;
}

//***********************************************************************
//	֐Fj["Output Mode Register" \
//	֐@FOnUpdateSelOutput
//		F	CCmdUI*		pCmdUI	CCmdUINX̃|C^
//***********************************************************************
void CMainFrame::OnUpdateSelOutput(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
}

//***********************************************************************
//	֐Fj["Output Mode Register" 
//	֐@FOnSelOutput
//***********************************************************************
void CMainFrame::OnSelOutput() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	COutputSelDlg*	pDlg;
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();
	
	pDlg	= new COutputSelDlg(pDoc);
	
	if(pDlg->DoModal() == IDOK)
	{
	}
	
	delete	pDlg;
}

//***********************************************************************
//	֐Fj["PU/PD Select Register" \
//	֐@FOnUpdateSelPupdCtrl
//		F	CCmdUI*		pCmdUI	CCmdUINX̃|C^
//***********************************************************************
void CMainFrame::OnUpdateSelPupdCtrl(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
}

//***********************************************************************
//	֐Fj["PU/PD Select Register" 
//	֐@FOnSelPupdCtrl
//***********************************************************************
void CMainFrame::OnSelPupdCtrl() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CPUDCtrlDlg*	pDlg;
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();
	
	pDlg	= new CPUDCtrlDlg(pDoc);
	
	if(pDlg->DoModal() == IDOK)
	{
	}
	
	delete	pDlg;
}

//***********************************************************************
//	֐Fj["ް" \
//	֐@FOnUpdateDispInput
//		F	CCmdUI*		pCmdUI	CCmdUINX̃|C^
//***********************************************************************
void CMainFrame::OnUpdateDispInput(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();

	if(pDoc->GetLogInputData())
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

//***********************************************************************
//	֐Fj["ް" 
//	֐@FOnDispInput
//***********************************************************************
void CMainFrame::OnDispInput() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();

	if(pDoc->GetLogInputData())
		pDoc->SetLogInputData(FALSE);
	else
		pDoc->SetLogInputData(TRUE);
}

//***********************************************************************
//	֐Fj["荞ү" \
//	֐@FOnUpdateDispInt
//		F	CCmdUI*		pCmdUI	CCmdUINX̃|C^
//***********************************************************************
void CMainFrame::OnUpdateDispInt(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();

	if(pDoc->GetLogIntMessage())
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

//***********************************************************************
//	֐Fj["荞ү" 
//	֐@FOnDispInt
//***********************************************************************
void CMainFrame::OnDispInt() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();

	if(pDoc->GetLogIntMessage())
		pDoc->SetLogIntMessage(FALSE);
	else
		pDoc->SetLogIntMessage(TRUE);
}

//***********************************************************************
//	֐Fj["G[bZ[W" \
//	֐@FOnUpdateDispError
//		F	CCmdUI*		pCmdUI	CCmdUINX̃|C^
//***********************************************************************
void CMainFrame::OnUpdateDispError(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();

	if(pDoc->GetLogErrorMessage())
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

//***********************************************************************
//	֐Fj["G[bZ[W" 
//	֐@FOnDispError
//***********************************************************************
void CMainFrame::OnDispError() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CAXCPI01Doc*	pDoc = (CAXCPI01Doc*)GetActiveDocument();

	if(pDoc->GetLogErrorMessage())
		pDoc->SetLogErrorMessage(FALSE);
	else
		pDoc->SetLogErrorMessage(TRUE);
}
