/*
	AxcpiLib.cpp
	
	Class for ADTEK SYSTEM SCIENCE Axcpi01w.dll utility.
	
*/


#include "stdafx.h"
//#define VC_EXTRALEAN		// Windows wb_[wǎgpȂX^btO܂B

//#include <afxwin.h>         // MFC ̃RAѕWR|[lg
//#include <afxext.h>         // MFC ̊g
//#include <afxcmn.h>			// MFC  Windows R Rg[ T|[g

#include "AxcpiLib.h"
#include "Axcpi01.h"
#include "Axcpi01w.h"
#include "Typedef.h"

//***********************************************************************
//	֐F׽̍\z
//	֐@FCAxcpiLib
//***********************************************************************
CAxcpiLib::CAxcpiLib()
{
	m_wLogSocket	= 0xffff;
}


//***********************************************************************
//	֐F׽̔j
//	֐@F~CAxcpiLib
//***********************************************************************
CAxcpiLib::~CAxcpiLib()
{
	Axcpi01wDllClose();
}


//***********************************************************************
//	֐F׽̏
//	֐@FCreate
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::Create(void)
{
	if(!Axcpi01wDllOpen())
	{
		return	FALSE;
	}
	return	TRUE;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01GetVersion() ̎s
//	֐@FUtyAxcpi01GetVersion
//		F	PDWORD 		pdwDllVersion	DLLo[Wi[|C^
//				PDWORD 		pdwDrvVersion	Drivero[Wi[|C^
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01GetVersion(PDWORD pdwDllVersion,PDWORD pdwDrvVersion)
{
	BOOL	bRet;

	bRet	= Axcpi01wGetVersion(pdwDllVersion,pdwDrvVersion);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01Create() ̎s
//	֐@FUtyAxcpi01Create
//		F	HWND 		hWnd			eWindow Handle
//				UINT 		uWMBase			Windows Message Base ԍ
//				PVOID 		pvInitArg		
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01Create(HWND hWnd,UINT uWMBase,PVOID pvInitArg)
{
	BOOL	bRet;

	bRet	= Axcpi01wCreate(&m_wLogSocket,hWnd,uWMBase,pvInitArg);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01Close() ̎s
//	֐@FUtyAxcpi01Close
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01Close(void)
{
	if(m_wLogSocket >= AXCPI01_MAX_SOCKETS)
		return	FALSE;

	BOOL	bRet;

	bRet	= Axcpi01wClose(m_wLogSocket);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01GetResource() ̎s
//	֐@FUtyAxcpi01GetResource
//		F	PDWORD 		pdwIOPortBase	I/Ox[XAhXi[|C^
//				PDWORD 		pdwIOPortLength	I/O|[gi[|C^
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01GetResource(PDWORD pdwIOPortBase,PDWORD pdwIOPortLength)
{
	if(m_wLogSocket >= AXCPI01_MAX_SOCKETS)
		return	FALSE;

	BOOL	bRet;

	bRet	= Axcpi01wGetResource(m_wLogSocket,pdwIOPortBase,pdwIOPortLength);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01InPortB() ̎s
//	֐@FUtyAxcpi01InPortB
//		F	DWORD 		dwPort			Register Index
//				PBYTE 		pbyValue		RegisterǍ݃f[^i[|C^
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01InPortB(DWORD dwPort,PBYTE pbyValue)
{
	if(m_wLogSocket >= AXCPI01_MAX_SOCKETS)
		return	FALSE;

	BOOL	bRet;

	bRet	= Axcpi01wInPortB(m_wLogSocket,dwPort,pbyValue);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01OutPortB() ̎s
//	֐@FUtyAxcpi01OutPortB
//		F	DWORD 		dwPort			Register Index
//				BYTE 		byValue			Register݃f[^
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01OutPortB(DWORD dwPort,BYTE byValue)
{
	if(m_wLogSocket >= AXCPI01_MAX_SOCKETS)
		return	FALSE;

	BOOL	bRet;

	bRet	= Axcpi01wOutPortB(m_wLogSocket,dwPort,byValue);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01InPortW() ̎s
//	֐@FUtyAxcpi01InPortW
//		F	DWORD 		dwPort			Register Index
//				PWORD 		pwValue			Register̓f[^i[|C^
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01InPortW(DWORD dwPort,PWORD pwValue)
{
	if(m_wLogSocket >= AXCPI01_MAX_SOCKETS)
		return	FALSE;

	BOOL	bRet;

	bRet	= Axcpi01wInPortW(m_wLogSocket,dwPort,pwValue);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01OutPortW() ̎s
//	֐@FUtyAxcpi01OutPortW
//		F	DWORD 		dwPort			Register Index
//				WORD 		wValue			Register݃f[^
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CAxcpiLib::UtyAxcpi01OutPortW(DWORD dwPort,WORD wValue)
{
	if(m_wLogSocket >= AXCPI01_MAX_SOCKETS)
		return	FALSE;

	BOOL	bRet;

	bRet	= Axcpi01wOutPortW(m_wLogSocket,dwPort,wValue);

	return	bRet;
}


//***********************************************************************
//	֐F"Axcpi01w.dll" Axcpi01GetLastError() ̎s
//	֐@FUtyAxcpi01GetLastError
//	߂l	F	DWORD		G[R[h
//***********************************************************************
DWORD CAxcpiLib::UtyAxcpi01GetLastError(void)
{
	WORD	wSocket	= m_wLogSocket;

	if(wSocket >= AXCPI01_MAX_SOCKETS)
		wSocket	= AXCPI01_SOCKET_AUTO;

	DWORD	dwError;

	dwError	= Axcpi01wGetLastError(wSocket);

	return	dwError;
}
