// AXCPI01View.cpp : CAXCPI01View NX̎
//

#include "stdafx.h"
#include "AXCPI01.h"
#include "typedef.h"

#include "AXCPI01Doc.h"
#include "AXCPI01View.h"

#include "AxcpiLib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAXCPI01View

IMPLEMENT_DYNCREATE(CAXCPI01View, CFormView)

BEGIN_MESSAGE_MAP(CAXCPI01View, CFormView)
	ON_BN_CLICKED(IDC_D0_BUTTON, OnD0Button)
	ON_BN_CLICKED(IDC_D1_BUTTON, OnD1Button)
	ON_BN_CLICKED(IDC_D2_BUTTON, OnD2Button)
	ON_BN_CLICKED(IDC_D3_BUTTON, OnD3Button)
	ON_BN_CLICKED(IDC_D4_BUTTON, OnD4Button)
	ON_BN_CLICKED(IDC_D5_BUTTON, OnD5Button)
	ON_BN_CLICKED(IDC_D6_BUTTON, OnD6Button)
	ON_BN_CLICKED(IDC_D7_BUTTON, OnD7Button)
	ON_BN_CLICKED(IDC_D8_BUTTON, OnD8Button)
	ON_BN_CLICKED(IDC_D9_BUTTON, OnD9Button)
	ON_BN_CLICKED(IDC_D10_BUTTON, OnD10Button)
	ON_BN_CLICKED(IDC_D11_BUTTON, OnD11Button)
	ON_BN_CLICKED(IDC_D12_BUTTON, OnD12Button)
	ON_BN_CLICKED(IDC_D13_BUTTON, OnD13Button)
	ON_BN_CLICKED(IDC_HELP_BUTTON, OnHelpButton)
	ON_BN_CLICKED(IDC_CLEAR_BUTTON, OnClearButton)
	ON_WM_CTLCOLOR()
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_COMMAND(IDM_VER_DRIVER, OnVerDriver)
	ON_COMMAND(IDM_VER_RESOURCE, OnVerResource)
	ON_MESSAGE(AXCPI01_WM_CARD_REMOVAL,OnCardRemove)
	ON_MESSAGE(AXCPI01_WM_IN,OnInterrupt)
	ON_MESSAGE(AXCPI01_WM_SUSPEND,OnPDASuspend)
	ON_MESSAGE(AXCPI01_WM_RESUME,OnPDAResume) 
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// CAXCPI01View RXgNV/fXgNV

//***********************************************************************
//	֐F׽̍\z
//	֐@FCAXCPI01View
//***********************************************************************
CAXCPI01View::CAXCPI01View()
	: CFormView(CAXCPI01View::IDD)
{
	// TODO: \zR[hɒǉ܂B

	m_bInit		= FALSE;
	m_uTimer	= 0;

// +++ V1005 ++++++++++++++++++++++ <S> +++
	m_Brs3DFace.CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	m_BrsBackGr.CreateSolidBrush(BACK_GR_COLOR);
// +++ V1005 ++++++++++++++++++++++ <E> +++
}

//***********************************************************************
//	֐F׽̔j
//	֐@F~CAXCPI01View
//***********************************************************************
CAXCPI01View::~CAXCPI01View()
{
}

//***********************************************************************
//	֐FData Exchange
//	֐@FDoDataExchange
//		F	CDataExchange* 	pDX		CDataExchangeNX|C^
//***********************************************************************
void CAXCPI01View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_TITLE2_BUTTON, m_Title2Btn);
	DDX_Control(pDX, IDC_TITLE1_BUTTON, m_Title1Btn);
	DDX_Control(pDX, IDC_DT9_STATIC, m_DT9Ctrl);
	DDX_Control(pDX, IDC_DT7_STATIC, m_DT7Ctrl);
	DDX_Control(pDX, IDC_DT6_STATIC, m_DT6Ctrl);
	DDX_Control(pDX, IDC_DT8_STATIC, m_DT8Ctrl);
	DDX_Control(pDX, IDC_DT5_STATIC, m_DT5Ctrl);
	DDX_Control(pDX, IDC_DT4_STATIC, m_DT4Ctrl);
	DDX_Control(pDX, IDC_DT3_STATIC, m_DT3Ctrl);
	DDX_Control(pDX, IDC_DT2_STATIC, m_DT2Ctrl);
	DDX_Control(pDX, IDC_DT13_STATIC, m_DT13Ctrl);
	DDX_Control(pDX, IDC_DT12_STATIC, m_DT12Ctrl);
	DDX_Control(pDX, IDC_DT11_STATIC, m_DT11Ctrl);
	DDX_Control(pDX, IDC_DT10_STATIC, m_DT10Ctrl);
	DDX_Control(pDX, IDC_DT1_STATIC, m_DT1Ctrl);
	DDX_Control(pDX, IDC_DT0_STATIC, m_DT0Ctrl);
	DDX_Control(pDX, IDC_UD9_STATIC, m_UD9Ctrl);
	DDX_Control(pDX, IDC_UD8_STATIC, m_UD8Ctrl);
	DDX_Control(pDX, IDC_UD7_STATIC, m_UD7Ctrl);
	DDX_Control(pDX, IDC_UD6_STATIC, m_UD6Ctrl);
	DDX_Control(pDX, IDC_UD5_STATIC, m_UD5Ctrl);
	DDX_Control(pDX, IDC_UD4_STATIC, m_UD4Ctrl);
	DDX_Control(pDX, IDC_UD3_STATIC, m_UD3Ctrl);
	DDX_Control(pDX, IDC_UD2_STATIC, m_UD2Ctrl);
	DDX_Control(pDX, IDC_UD13_STATIC, m_UD13Ctrl);
	DDX_Control(pDX, IDC_UD12_STATIC, m_UD12Ctrl);
	DDX_Control(pDX, IDC_UD11_STATIC, m_UD11Ctrl);
	DDX_Control(pDX, IDC_UD10_STATIC, m_UD10Ctrl);
	DDX_Control(pDX, IDC_UD1_STATIC, m_UD1Ctrl);
	DDX_Control(pDX, IDC_UD0_STATIC, m_UD0Ctrl);
	DDX_Control(pDX, IDC_LOG_LIST, m_LogList);
	DDX_Control(pDX, IDC_TITLE2_STATIC, m_Title2Ctrl);
	DDX_Control(pDX, IDC_TITLE_STATIC, m_Title1Ctrl);
	DDX_Control(pDX, IDC_CLEAR_BUTTON, m_ClearBtn);
	DDX_Control(pDX, IDC_HELP_BUTTON, m_HelpBtn);
	DDX_Control(pDX, IDC_D9_BUTTON, m_D9Btn);
	DDX_Control(pDX, IDC_D8_BUTTON, m_D8Btn);
	DDX_Control(pDX, IDC_D7_BUTTON, m_D7Btn);
	DDX_Control(pDX, IDC_D6_BUTTON, m_D6Btn);
	DDX_Control(pDX, IDC_D5_BUTTON, m_D5Btn);
	DDX_Control(pDX, IDC_D4_BUTTON, m_D4Btn);
	DDX_Control(pDX, IDC_D3_BUTTON, m_D3Btn);
	DDX_Control(pDX, IDC_D2_BUTTON, m_D2Btn);
	DDX_Control(pDX, IDC_D13_BUTTON, m_D13Btn);
	DDX_Control(pDX, IDC_D12_BUTTON, m_D12Btn);
	DDX_Control(pDX, IDC_D11_BUTTON, m_D11Btn);
	DDX_Control(pDX, IDC_D10_BUTTON, m_D10Btn);
	DDX_Control(pDX, IDC_D1_BUTTON, m_D1Btn);
	DDX_Control(pDX, IDC_D0_BUTTON, m_D0Btn);
}

//***********************************************************************
//	֐FWindow ̍\z
//	֐@FPreCreateWindow
//		F	CREATESTRUCT&	cs		CREATESTRUCTNX|C^
//***********************************************************************
BOOL CAXCPI01View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CFormView::PreCreateWindow(cs);
}



//***********************************************************************
//	֐Fi\j
//	֐@FOnInitialUpdate
//***********************************************************************
void CAXCPI01View::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();

	if(!m_bInit)
	{
		if(!pApp->m_AxcpiLib.Create())
		{
			CString	strError;
			
			strError.LoadString(IDS_DLL_LOAD_FAIL);
			LogErrorMessage(strError);
		}
		else
		{
			if(!pApp->m_AxcpiLib.UtyAxcpi01Create(this->GetSafeHwnd(),AXCPI01_WM_USER,NULL))
			{
				LogErrorMessage2();
			}
			else
			{
				// f[^̏o
				WORD	wTemp;

				// Output Port Data
				wTemp	= pDoc->GetPIOOutData();
				if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wTemp))
				{
					LogErrorMessage2();
				}

				// Output Enable Register
				wTemp	= pDoc->GetPIOMode();
				if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_IO_SELECT_L,wTemp))
				{
					LogErrorMessage2();
				}

				// Output Select Register
				wTemp	= pDoc->GetPIOOutMode();
				if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_OUTPUT_MODE_L,wTemp))
				{
					LogErrorMessage2();
				}

				// Pull Up/Down Register
				wTemp	= pDoc->GetPIOPullUD();
				if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_PUPD_SELECT_L,wTemp))
				{
					LogErrorMessage2();
				}

				// Interrypt Setting Register
				wTemp	= pDoc->GetPIOIntSet();
				if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortB(AXCPI01_PORT_IRQ_L,(BYTE)(wTemp & 0xff)))
				{
					LogErrorMessage2();
				}

				// Get Input Data
				wTemp	= 0xffff;
				if(!pApp->m_AxcpiLib.UtyAxcpi01InPortW(AXCPI01_PORT_PUPD_SELECT_L,&wTemp))
				{
					LogErrorMessage2();
				}
				pDoc->SetPIOInData(wTemp);

				// Font ̐ݒ
				CString		strFont;
				strFont = TEXT("lr@SVbN");
				//
				// Create the option font
				//
				// Points  8 : -11
				//         9 : -12
				//		  10 : -13
				int		nHeight = -13;
				m_FontList.CreateFont(nHeight, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, strFont);
				m_LogList.SetFont(&m_FontList);			//̫Ă̎w

				// CjV̏I
				m_bInit	= TRUE;
			}
		}
		if(!m_bInit)
		{	// s
			AfxMessageBox(IDS_ERR_NO_DEVICE_EXIT);
			pApp->m_pMainWnd->DestroyWindow();					// V1005
//			PostQuitMessage(0);
		}
	}
	
	// Bitmap Button ̐ݒ
	m_ClearBtn.SetDocument(pDoc);
	m_HelpBtn.SetDocument(pDoc);
	m_D0Btn.SetDocument(pDoc);
	m_D1Btn.SetDocument(pDoc);
	m_D2Btn.SetDocument(pDoc);
	m_D3Btn.SetDocument(pDoc);
	m_D4Btn.SetDocument(pDoc);
	m_D5Btn.SetDocument(pDoc);
	m_D6Btn.SetDocument(pDoc);
	m_D7Btn.SetDocument(pDoc);
	m_D8Btn.SetDocument(pDoc);
	m_D9Btn.SetDocument(pDoc);
	m_D10Btn.SetDocument(pDoc);
	m_D11Btn.SetDocument(pDoc);
	m_D12Btn.SetDocument(pDoc);
	m_D13Btn.SetDocument(pDoc);

	// ͊Ďp^C}[̃X^[g
	if(m_bInit)
	{	// 
		m_uTimer	= SetTimer(1, 100, NULL);			//\pϰN
	}
}


// CAXCPI01View ff

#ifdef _DEBUG
void CAXCPI01View::AssertValid() const
{
	CFormView::AssertValid();
}

CAXCPI01Doc* CAXCPI01View::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAXCPI01Doc)));
	return (CAXCPI01Doc*)m_pDocument;
}
#endif //_DEBUG


// CAXCPI01View bZ[W nh
//***********************************************************************
//	֐F"D0" {^
//	֐@FOnD0Button
//***********************************************************************
void CAXCPI01View::OnD0Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0001))
	{
		wData ^= 0x0001;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D0Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D1" {^
//	֐@FOnD1Button
//***********************************************************************
void CAXCPI01View::OnD1Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0002))
	{
		wData ^= 0x0002;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D1Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D2" {^
//	֐@FOnD2Button
//***********************************************************************
void CAXCPI01View::OnD2Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0004))
	{
		wData ^= 0x0004;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D2Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D3" {^
//	֐@FOnD3Button
//***********************************************************************
void CAXCPI01View::OnD3Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0008))
	{
		wData ^= 0x0008;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D3Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D4" {^
//	֐@FOnD4Button
//***********************************************************************
void CAXCPI01View::OnD4Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0010))
	{
		wData ^= 0x0010;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D4Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D5" {^
//	֐@FOnD5Button
//***********************************************************************
void CAXCPI01View::OnD5Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0020))
	{
		wData ^= 0x0020;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D5Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D6" {^
//	֐@FOnD6Button
//***********************************************************************
void CAXCPI01View::OnD6Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0040))
	{
		wData ^= 0x0040;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D6Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D7" {^
//	֐@FOnD7Button
//***********************************************************************
void CAXCPI01View::OnD7Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0080))
	{
		wData ^= 0x0080;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D7Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D8" {^
//	֐@FOnD8Button
//***********************************************************************
void CAXCPI01View::OnD8Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0100))
	{
		wData ^= 0x0100;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D8Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D9" {^
//	֐@FOnD9Button
//***********************************************************************
void CAXCPI01View::OnD9Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0200))
	{
		wData ^= 0x0200;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D9Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D10" {^
//	֐@FOnD10Button
//***********************************************************************
void CAXCPI01View::OnD10Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0400))
	{
		wData ^= 0x0400;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D10Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D11" {^
//	֐@FOnD11Button
//***********************************************************************
void CAXCPI01View::OnD11Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x0800))
	{
		wData ^= 0x0800;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D11Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D12" {^
//	֐@FOnD12Button
//***********************************************************************
void CAXCPI01View::OnD12Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x1000))
	{
		wData ^= 0x1000;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D12Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"D13" {^
//	֐@FOnD13Button
//***********************************************************************
void CAXCPI01View::OnD13Button() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	WORD			wData	= pDoc->GetPIOOutData();

	if(!(pDoc->GetPIOMode() & 0x2000))
	{
		wData ^= 0x2000;

		// Output Port Data
		if(!pApp->m_AxcpiLib.UtyAxcpi01OutPortW(AXCPI01_PORT_DATA_L,wData))
		{
			LogErrorMessage2();
		}

		pDoc->SetPIOOutData(wData);
		m_D13Btn.Invalidate();
	}
}

//***********************************************************************
//	֐F"Help" {^
//	֐@FOnHelpButton
//***********************************************************************
void CAXCPI01View::OnHelpButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// Help
	int		nLine	= m_LogList.GetCount();

	m_LogList.DeleteString(nLine - 1);
	m_LogList.DeleteString(nLine - 2);
	m_LogList.DeleteString(nLine - 3);
	m_LogList.DeleteString(nLine - 4);
	m_LogList.DeleteString(nLine - 5);
	nLine	-= 5;

	m_LogList.AddString(TEXT("** Data Register **"));
	m_LogList.AddString(TEXT("I/O F14_(D13`D0)"));
	m_LogList.AddString(TEXT("FRead/Write"));
	m_LogList.AddString(TEXT("f[^Mp̃WX^łB"));
	m_LogList.AddString(TEXT("uI/O Select Registerv 0 ɐݒ肵r"));
	m_LogList.AddString(TEXT("bgo͂ƂȂA1 ɐݒ肵rbg͓"));
	m_LogList.AddString(TEXT("͂ƂȂ܂B"));
	m_LogList.AddString(TEXT("f[^CgꍇÃf[^͕ێ"));
	m_LogList.AddString(TEXT("Ao͂ɐݒ肵rbgɑΉ I/O"));
	m_LogList.AddString(TEXT("RlN^̐Mɔf܂B"));
	m_LogList.AddString(TEXT("f[^[hꍇAo͂̑"));
	m_LogList.AddString(TEXT("ւ炸 I/ORlN^̐M̏Ԃǂ"));
	m_LogList.AddString(TEXT("܂܂B"));
	m_LogList.AddString(TEXT("̃WX^̏l̓I[1łB"));
	m_LogList.AddString(TEXT(""));
	m_LogList.AddString(TEXT(""));
	m_LogList.AddString(TEXT(""));
	m_LogList.AddString(TEXT(""));
	m_LogList.AddString(TEXT(""));
	
	m_LogList.SetTopIndex(nLine);
}

//***********************************************************************
//	֐F"Clear" {^
//	֐@FOnClearButton
//***********************************************************************
void CAXCPI01View::OnClearButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_LogList.ResetContent();
}

//***********************************************************************
//	֐FJ[`惁bZ[W
//	֐@FOnCtlColor
//		F	CDC* 		pDC			`CDC|C^
//				CWnd* 		pWnd		`WindowiRg[jNX|C^
//				UINT 		nCtlColor	`tO
//	߂l	F	(HBRUSH)uṼnh
//***********************************************************************
HBRUSH CAXCPI01View::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	if(nCtlColor == CTLCOLOR_STATIC)
	{
		if(pWnd == &m_Title1Ctrl || pWnd == &m_Title2Ctrl)
		{
			pDC->SetBkMode(TRANSPARENT);
// +++ V1005 ++++++++++++++++++++++ <S> +++
//			return ::CreateSolidBrush(GetSysColor(COLOR_3DFACE));
			return	(HBRUSH)m_Brs3DFace;
// +++ V1005 ++++++++++++++++++++++ <E> +++
		}
	
		// Pull UP/DOWN ̕\
		CAXCPI01Doc* pDoc		= GetDocument();
		WORD		wPIOPullUD	= pDoc->GetPIOPullUD();

		// bit.0
		if(pWnd == &m_UD0Ctrl)
		{
			if(wPIOPullUD & 0x0001)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.1
		if(pWnd == &m_UD1Ctrl)
		{
			if(wPIOPullUD & 0x0002)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
			pDC->SetBkMode(TRANSPARENT);
			pDC->SetBkColor(RGB(230,230,230));
		}

		// bit.2
		if(pWnd == &m_UD2Ctrl)
		{
			if(wPIOPullUD & 0x0004)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.3
		if(pWnd == &m_UD3Ctrl)
		{
			if(wPIOPullUD & 0x0008)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.4
		if(pWnd == &m_UD4Ctrl)
		{
			if(wPIOPullUD & 0x0010)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.5
		if(pWnd == &m_UD5Ctrl)
		{
			if(wPIOPullUD & 0x0020)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.6
		if(pWnd == &m_UD6Ctrl)
		{
			if(wPIOPullUD & 0x0040)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.7
		if(pWnd == &m_UD7Ctrl)
		{
			if(wPIOPullUD & 0x0080)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.8
		if(pWnd == &m_UD8Ctrl)
		{
			if(wPIOPullUD & 0x0100)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.9
		if(pWnd == &m_UD9Ctrl)
		{
			if(wPIOPullUD & 0x0200)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.10
		if(pWnd == &m_UD10Ctrl)
		{
			if(wPIOPullUD & 0x0400)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.11
		if(pWnd == &m_UD11Ctrl)
		{
			if(wPIOPullUD & 0x0800)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.12
		if(pWnd == &m_UD12Ctrl)
		{
			if(wPIOPullUD & 0x1000)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// bit.13
		if(pWnd == &m_UD13Ctrl)
		{
			if(wPIOPullUD & 0x2000)
				pDC->SetTextColor(PU_COLOR);
			else
				pDC->SetTextColor(PD_COLOR);
		}

		// wiF̐ݒ
		if(	(pWnd == &m_UD0Ctrl)	||
			(pWnd == &m_UD1Ctrl)	||
			(pWnd == &m_UD2Ctrl)	||
			(pWnd == &m_UD3Ctrl)	||
			(pWnd == &m_UD4Ctrl)	||
			(pWnd == &m_UD5Ctrl)	||
			(pWnd == &m_UD6Ctrl)	||
			(pWnd == &m_UD7Ctrl)	||
			(pWnd == &m_UD8Ctrl)	||
			(pWnd == &m_UD9Ctrl)	||
			(pWnd == &m_UD10Ctrl)	||
			(pWnd == &m_UD11Ctrl)	||
			(pWnd == &m_UD12Ctrl)	||
			(pWnd == &m_UD13Ctrl)	||
			(pWnd == &m_DT0Ctrl)	||
			(pWnd == &m_DT1Ctrl)	||
			(pWnd == &m_DT2Ctrl)	||
			(pWnd == &m_DT3Ctrl)	||
			(pWnd == &m_DT4Ctrl)	||
			(pWnd == &m_DT5Ctrl)	||
			(pWnd == &m_DT6Ctrl)	||
			(pWnd == &m_DT7Ctrl)	||
			(pWnd == &m_DT8Ctrl)	||
			(pWnd == &m_DT9Ctrl)	||
			(pWnd == &m_DT10Ctrl)	||
			(pWnd == &m_DT11Ctrl)	||
			(pWnd == &m_DT12Ctrl)	||
			(pWnd == &m_DT13Ctrl)	)
		{
			pDC->SetBkColor(BACK_GR_COLOR);
// +++ V1005 ++++++++++++++++++++++ <S> +++
//			hbr	= ::CreateSolidBrush(BACK_GR_COLOR);
			hbr	= (HBRUSH)m_BrsBackGr;
// +++ V1005 ++++++++++++++++++++++ <E> +++
		}
	}
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}

//***********************************************************************
//	֐F`惁bZ[W
//	֐@FOnDraw
//		F	CDC* 		pDC			`CDC|C^
//***********************************************************************
void CAXCPI01View::OnDraw(CDC* pDC) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CRect		rcBase, rcCtl, rc, rc2;
	int			nWidth, nTemp, nTemp2;
	CString		strBuffer;

	//ް̏
	rcBase.left		= 0;
	rcBase.top 		= 0;
	rcBase.right	= GetSystemMetrics(SM_CXSCREEN);
	rcBase.bottom	= GetSystemMetrics(SM_CYSCREEN)-MENU_HEIGHT-MENU_HEIGHT;
	rcCtl 			= rcBase;
	rcCtl.top 		= HEDER_HEIGHT;							//ͯް
	nWidth 			= rcCtl.Width()-SCROLL_WIDTH;			//ؽĺ۰ٕ擾(۰,̾Ă͊܂܂)
	nTemp			= 1;

//	m_Title1Ctrl.MoveWindow(0, 0, rcCtl.Width()/2,HEDER_HEIGHT);
	m_Title1Ctrl.MoveWindow(0, 0, 0, 0);

	rc2.left	= 0/*rcCtl.Width()/2*/;
	rc2.top		= 0;
	rc2.right	= rcCtl.right;
	rc2.bottom	= HEDER_HEIGHT;
	pDC->FillRect(rc2, &CBrush(::GetSysColor(COLOR_3DFACE)));			//lp`hԂ
	m_Title1Btn.GetWindowRect(&rc);
	m_Title1Btn.MoveWindow(TITLE_X,TITLE_Y,rc.Width(),rc.Height());

	m_HelpBtn.GetWindowRect(&rc2);
	m_HelpBtn.MoveWindow(rc2.left,nTemp,rc2.Width(),rc2.Height());

	m_Title2Ctrl.GetWindowRect(&rc2);
	m_Title2Ctrl.MoveWindow(0, rc2.top-MENU_HEIGHT, 1, 1);
//	m_Title2Ctrl.MoveWindow(rc2.left, rc2.top, 0, 0);
	rc2.left	= 0/*rcCtl.Width()/2*/;
	rc2.top		= rc2.top-MENU_HEIGHT;
	rc2.right	= rcCtl.right;
	rc2.bottom	= rc2.top+HEDER_HEIGHT;
	pDC->FillRect(rc2, &CBrush(::GetSysColor(COLOR_3DFACE)));			//lp`hԂ
	nTemp		= rc2.top + 1;
	nTemp2		= rc2.bottom;
	m_Title2Btn.GetWindowRect(&rc);
	m_Title2Btn.MoveWindow(TITLE_X,rc2.top+TITLE_Y,rc.Width(),rc.Height());

	// wiF̕`
	CRect	rcBack;
	rcBack.top		= HEDER_HEIGHT;
	rcBack.bottom	= rc2.top;
	rcBack.left		= 0;
	rcBack.right	= rcCtl.right;
	pDC->FillRect(rcBack, &CBrush(BACK_GR_COLOR));			//lp`hԂ

	// E`
	CPen*	pOldPen;
	CPen	PenData1(PS_SOLID,1,PEN1_COLOR);
	CPen	PenData2(PS_SOLID,1,PEN2_COLOR);

	pOldPen		= pDC->SelectObject(&PenData1);

	int	nPosY	= rcBack.top + (rcBack.bottom - rcBack.top) / 2;
	pDC->MoveTo(0,nPosY);
	pDC->LineTo(rcBack.right,nPosY);
	pDC->SelectObject(pOldPen);

	pOldPen		= pDC->SelectObject(&PenData2);
	pDC->MoveTo(0,rcBack.top);
	pDC->LineTo(rcBack.right,rcBack.top);
	pDC->MoveTo(0,rcBack.bottom-1);
	pDC->LineTo(rcBack.right,rcBack.bottom-1);
	pDC->SelectObject(pOldPen);

	m_ClearBtn.GetWindowRect(&rc2);
	m_ClearBtn.MoveWindow(rc2.left,nTemp,rc2.Width(),rc2.Height());

	m_LogList.MoveWindow(0,nTemp2,rcCtl.Width(),rcCtl.bottom-nTemp2);

	// Pull UP/DOWN ̕\
	CAXCPI01Doc* pDoc		= GetDocument();
	WORD		wPIOPullUD	= pDoc->GetPIOPullUD();

	// bit.0
	if(wPIOPullUD & 0x0001)
		m_UD0Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD0Ctrl.SetWindowText(TEXT("PD"));

	// bit.1
	if(wPIOPullUD & 0x0002)
		m_UD1Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD1Ctrl.SetWindowText(TEXT("PD"));

	// bit.2
	if(wPIOPullUD & 0x0004)
		m_UD2Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD2Ctrl.SetWindowText(TEXT("PD"));

	// bit.3
	if(wPIOPullUD & 0x0008)
		m_UD3Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD3Ctrl.SetWindowText(TEXT("PD"));

	// bit.4
	if(wPIOPullUD & 0x0010)
		m_UD4Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD4Ctrl.SetWindowText(TEXT("PD"));

	// bit.5
	if(wPIOPullUD & 0x0020)
		m_UD5Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD5Ctrl.SetWindowText(TEXT("PD"));

	// bit.6
	if(wPIOPullUD & 0x0040)
		m_UD6Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD6Ctrl.SetWindowText(TEXT("PD"));

	// bit.7
	if(wPIOPullUD & 0x0080)
		m_UD7Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD7Ctrl.SetWindowText(TEXT("PD"));

	// bit.8
	if(wPIOPullUD & 0x0100)
		m_UD8Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD8Ctrl.SetWindowText(TEXT("PD"));

	// bit.9
	if(wPIOPullUD & 0x0200)
		m_UD9Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD9Ctrl.SetWindowText(TEXT("PD"));

	// bit.10
	if(wPIOPullUD & 0x0400)
		m_UD10Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD10Ctrl.SetWindowText(TEXT("PD"));

	// bit.11
	if(wPIOPullUD & 0x0800)
		m_UD11Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD11Ctrl.SetWindowText(TEXT("PD"));

	// bit.12
	if(wPIOPullUD & 0x1000)
		m_UD12Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD12Ctrl.SetWindowText(TEXT("PD"));

	// bit.13
	if(wPIOPullUD & 0x2000)
		m_UD13Ctrl.SetWindowText(TEXT("PU"));
	else
		m_UD13Ctrl.SetWindowText(TEXT("PD"));
}

//***********************************************************************
//	֐FJ[h胁bZ[W
//	֐@FOnCardRemove
//		F	WPARAM		wParam		bZ[Whc
//				LPARAM 		lParam		bZ[Wp[^
//***********************************************************************
LRESULT CAXCPI01View::OnCardRemove(WPARAM wParam,LPARAM lParam)
{
	// ͂߂Ƀ^C}[~߂
	if(m_uTimer != 0)
	{
		KillTimer(m_uTimer);						//ϰI
		m_uTimer = 0;								//
	}

	AfxMessageBox(IDS_CARD_REMOVE);

	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();	// V1005
// 2007.03.03 : ADD -->
	if(m_bInit)
	{
		pApp->m_AxcpiLib.UtyAxcpi01Close();
		m_bInit	= FALSE;
	}
// <-- 2007.03.03 : ADD
	pApp->m_pMainWnd->DestroyWindow();						// V1005
//	PostQuitMessage(0);

#if 0
	CString	strMes1,strMes2,strMes3,strMes4;
		
	strMes1.Empty();
	strMes2.Empty();
	strMes3.Empty();
	strMes4.Empty();

	strMes1.LoadString(IDS_ERROR_LOG);
	strMes2.LoadString(IDS_CARD_REMOVE);

	MakeLogList(strMes1,strMes2,strMes3,strMes4);

	if(m_uTimer != 0)
	{
		KillTimer(m_uTimer);						//ϰI
		m_uTimer = 0;								//
	}
#endif

	return	0;
}

//***********************************************************************
//	֐F荞ݔ(IRQ)bZ[W
//	֐@FOnInterrupt
//		F	WPARAM		wParam		bZ[Whc
//				LPARAM 		lParam		bZ[Wp[^
//***********************************************************************
LRESULT CAXCPI01View::OnInterrupt(WPARAM wParam,LPARAM lParam)
{
	if(wParam & 0x02)
	{	// IRQ2
		LogInterrupt(2);
	}
	if(wParam & 0x01)
	{	// IRQ1
		LogInterrupt(1);
	}

	return	0;
}

// 2007.03.03 : ADD -->
//***********************************************************************
//	֐FPDA TXyhbZ[W
//	֐@FOnPDASuspend
//		F	WPARAM		wParam		bZ[Whc
//				LPARAM 		lParam		bZ[Wp[^
//***********************************************************************
LRESULT CAXCPI01View::OnPDASuspend(WPARAM wParam,LPARAM lParam)
{
//	AfxMessageBox(TEXT("PDA Suspend"));

	return	0;
}

//***********************************************************************
//	֐FPDA W[bZ[W
//	֐@FOnPDAResume
//		F	WPARAM		wParam		bZ[Whc
//				LPARAM 		lParam		bZ[Wp[^
//***********************************************************************
LRESULT CAXCPI01View::OnPDAResume(WPARAM wParam,LPARAM lParam)
{
//	AfxMessageBox(TEXT("PDA Resume"));

#if 1
	// ͂߂Ƀ^C}[~߂
	if(m_uTimer != 0)
	{
		KillTimer(m_uTimer);						//ϰI
		m_uTimer = 0;								//
	}

//	AfxMessageBox(IDS_CARD_REMOVE);

	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();

	if(m_bInit)
	{
// 2007.06.12 ADD -->  Ӑ}IɁÃI[vG[Ƃ
#if 0
		pApp->m_AxcpiLib.UtyAxcpi01Close();
#endif
// <-- 2007.06.12 ADD
		m_bInit	= FALSE;
	}
	pApp->m_pMainWnd->DestroyWindow();
#endif

	return	0;
}
// <-- 2007.03.03 : ADD

//
//***********************************************************************
//	֐F̓f[^ωO\
//	֐@FLogInputData
//		F	WORD 		wOldData		̓f[^
//				WORD 		wNewData		V̓f[^
//***********************************************************************
void CAXCPI01View::LogInputData(WORD wOldData,WORD wNewData)
{
	CAXCPI01Doc* pDoc		= GetDocument();

	if(pDoc->GetLogInputData())
	{
		CString	strMes1,strMes2,strMes3,strMes4;
		
		strMes1.Empty();
		strMes2.Empty();
		strMes3.Empty();
		strMes4.Empty();

		strMes1.LoadString(IDS_INPUTDATA_LOG);
		strMes2.LoadString(IDS_INPUTDATA_LOG2);

		WORD	wPIOMode	= pDoc->GetPIOMode();

		// D13
		if(wPIOMode & 0x2000)
		{	// ̓|[g
			if(wNewData & 0x2000)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D12
		if(wPIOMode & 0x1000)
		{	// ̓|[g
			if(wNewData & 0x1000)
				strMes2	+= TEXT("1 - ");
			else
				strMes2	+= TEXT("0 - ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X - ");
		}

		// D11
		if(wPIOMode & 0x0800)
		{	// ̓|[g
			if(wNewData & 0x0800)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D10
		if(wPIOMode & 0x0400)
		{	// ̓|[g
			if(wNewData & 0x0400)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D9
		if(wPIOMode & 0x0200)
		{	// ̓|[g
			if(wNewData & 0x0200)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D8
		if(wPIOMode & 0x0100)
		{	// ̓|[g
			if(wNewData & 0x0100)
				strMes2	+= TEXT("1 - ");
			else
				strMes2	+= TEXT("0 - ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X - ");
		}

		// D7
		if(wPIOMode & 0x0080)
		{	// ̓|[g
			if(wNewData & 0x0080)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D6
		if(wPIOMode & 0x0040)
		{	// ̓|[g
			if(wNewData & 0x0040)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D5
		if(wPIOMode & 0x0020)
		{	// ̓|[g
			if(wNewData & 0x0020)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D4
		if(wPIOMode & 0x0010)
		{	// ̓|[g
			if(wNewData & 0x0010)
				strMes2	+= TEXT("1 - ");
			else
				strMes2	+= TEXT("0 - ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X - ");
		}

		// D3
		if(wPIOMode & 0x0008)
		{	// ̓|[g
			if(wNewData & 0x0008)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D2
		if(wPIOMode & 0x0004)
		{	// ̓|[g
			if(wNewData & 0x0004)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D1
		if(wPIOMode & 0x0002)
		{	// ̓|[g
			if(wNewData & 0x0002)
				strMes2	+= TEXT("1 ");
			else
				strMes2	+= TEXT("0 ");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X ");
		}

		// D0
		if(wPIOMode & 0x0001)
		{	// ̓|[g
			if(wNewData & 0x0001)
				strMes2	+= TEXT("1");
			else
				strMes2	+= TEXT("0");
		}
		else
		{	// o̓|[g
			strMes2	+= TEXT("X");
		}

		MakeLogList(strMes1,strMes2,strMes3,strMes4);
	}
}

//***********************************************************************
//	֐F荞ݔO\
//	֐@FLogInterrupt
//		F	int 		nIRQ			荞݂mD
//***********************************************************************
void CAXCPI01View::LogInterrupt(int nIRQ)
{
	CAXCPI01Doc* pDoc		= GetDocument();

	if(pDoc->GetLogIntMessage())
	{
		CString	strMes1,strMes2,strMes3,strMes4;
		
		strMes1.Empty();
		strMes2.Empty();
		strMes3.Empty();
		strMes4.Empty();

		strMes1.LoadString(IDS_INTERRUPT_LOG);
		strMes2.Format(TEXT("IRQIN%d"),nIRQ);
		MakeLogList(strMes1,strMes2,strMes3,strMes4);
	}
}

//***********************************************************************
//	֐FG[O\
//	֐@FLogErrorMessage
//		F	CString 	strError1		O\
//***********************************************************************
void CAXCPI01View::LogErrorMessage(CString strError1)
{
	CAXCPI01Doc* pDoc		= GetDocument();

	if(pDoc->GetLogErrorMessage())
	{
		CString	strMes1,strMes2;
		
		strMes1.Empty();
		strMes2.Empty();

		strMes1.LoadString(IDS_ERROR_LOG);

		MakeLogList(strMes1,strError1,strMes2,strMes2);
	}
}

//***********************************************************************
//	֐FG[O\iG[ԍt^j
//	֐@FLogErrorMessage2
//***********************************************************************
void CAXCPI01View::LogErrorMessage2(void)
{
	CAXCPI01Doc*	pDoc		= GetDocument();
	CAXCPI01App*	pApp 		= (CAXCPI01App*)AfxGetApp();

	if(pDoc->GetLogErrorMessage())
	{
		DWORD	dwError;
		DWORD	dwSysError	= 0;

		dwError	= pApp->m_AxcpiLib.UtyAxcpi01GetLastError();
		if(dwError == AXCPI01_ERR_SYSTEM)
			dwSysError	= GetLastError();

		CString	strMes1,strMes2,strMes3,strMes4;
		
		strMes1.LoadString(IDS_ERROR_LOG);
		strMes2.Format(TEXT("%08XH"),dwError);

		switch(dwError)
		{
			case	AXCPI01_SUCCESS:  				// ُȂiIj
				return;
//				strMes3.LoadString(IDS_ERR_SUCCESS);
//				strMes4.Empty();
				break;
			case	AXCPI01_ERR_SYSTEM:				// Windows  GetLastError() R[Ă
													// ɃhCo[hĂȂ\܂
				strMes3.LoadString(IDS_ERR_SYSTEM);
				strMes4.LoadString(IDS_ERR_SYSTEM2);
				break;
			case	AXCPI01_ERR_NO_DEVICE:			// gp\ȃfoCX܂
				strMes3.LoadString(IDS_ERR_NO_DEVICE);
				strMes4.Empty();
				break;
			case	AXCPI01_ERR_IN_USE:				// w̃foCX͎gpł
				strMes3.LoadString(IDS_ERR_IN_USE);
				strMes4.LoadString(IDS_ERR_IN_USE2);
				break;
			case	AXCPI01_ERR_INVALID_SOCKET:		// Ș_\Pbgł
				strMes3.LoadString(IDS_ERR_INVALID_SOCKET);
				strMes4.Empty();
				break;
			case	AXCPI01_ERR_RESOURCE:			// \[XG[
				strMes3.LoadString(IDS_ERR_RESOURCE);
				strMes4.Empty();
				break;
			case	AXCPI01_ERR_INVALID_PORT:		// sȃ|[gv܂
				strMes3.LoadString(IDS_ERR_INVALID_PORT);
				strMes4.Empty();
				break;
			case	AXCPI01_ERR_INVALID_ARGUMENT:	// sȈv܂
				strMes3.LoadString(IDS_ERR_INVALID_ARGUMENT);
				strMes4.Empty();
				break;
			default:
				return;
		}

		MakeLogList(strMes1,strMes2,strMes3,strMes4);
	}
}

//***********************************************************************
//	֐FO\Xg쐬i\j|l4s̃Oǉ
//	֐@FMakeLogList
//		F	CString 	strError1		O\
//				CString 	strError2		O\
//				CString 	strError3		O\
//				CString 	strError4		O\
//***********************************************************************
void CAXCPI01View::MakeLogList(CString strMes1,CString strMes2,CString strMes3,CString strMes4)
{
	int		nLine	= m_LogList.GetCount();
	
	if(nLine < LOG_MAX_LINE)
	{
		if(nLine <= 0)
		{
			if(!strMes1.IsEmpty())
			{
				m_LogList.AddString(strMes1);
				if(!strMes2.IsEmpty())
				{
					m_LogList.AddString(strMes2);
					if(!strMes3.IsEmpty())
					{
						m_LogList.AddString(strMes3);
						if(!strMes4.IsEmpty())
						{
							m_LogList.AddString(strMes4);
						}
					}
				}
			}
			m_LogList.AddString(TEXT(""));
			m_LogList.AddString(TEXT(""));
			m_LogList.AddString(TEXT(""));
			m_LogList.AddString(TEXT(""));
			m_LogList.AddString(TEXT(""));
		}
		else
		{
			if(!strMes1.IsEmpty())
			{
				m_LogList.InsertString(nLine - 5,strMes1);
				if(!strMes2.IsEmpty())
				{
					m_LogList.InsertString(nLine - 4,strMes2);
					if(!strMes3.IsEmpty())
					{
						m_LogList.InsertString(nLine - 3,strMes3);
						if(!strMes4.IsEmpty())
						{
							m_LogList.InsertString(nLine - 2,strMes4);
						}
					}
				}
			}
		}
		nLine	= m_LogList.GetCount();
		if(!strMes4.IsEmpty())
			m_LogList.SetTopIndex(nLine-5-4);
		else if(!strMes3.IsEmpty())
			m_LogList.SetTopIndex(nLine-5-3);
		else if(!strMes2.IsEmpty())
			m_LogList.SetTopIndex(nLine-5-2);
		else if(!strMes1.IsEmpty())
			m_LogList.SetTopIndex(nLine-5-1);
	}
}


//***********************************************************************
//	֐F^C}[Ď|̓f[^̊Ď
//	֐@FOnTimer
//		F	UINT 	nIDEvent		^C}[hc
//***********************************************************************
void CAXCPI01View::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	if(nIDEvent == m_uTimer)
	{
		CAXCPI01Doc* 	pDoc	= GetDocument();
		CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
		WORD			wInData,wInDataOrg,wDocData;

		wDocData	= pDoc->GetPIOInData();
		if(!pApp->m_AxcpiLib.UtyAxcpi01InPortW(AXCPI01_PORT_DATA_L,&wInData))
		{
			DWORD	dwError;

			dwError	= pApp->m_AxcpiLib.UtyAxcpi01GetLastError();
			if(dwError == AXCPI01_ERR_NO_DEVICE || dwError == 0xffffffff)
			{
				// ͂߂Ƀ^C}[~߂
				if(m_uTimer != 0)
				{
					KillTimer(m_uTimer);						//ϰI
					m_uTimer = 0;								//
				}

				AfxMessageBox(IDS_ERR_NO_DEVICE_EXIT);
				pApp->m_pMainWnd->DestroyWindow();						// V1005
//				PostQuitMessage(0);
			}

			LogErrorMessage2();
		}
		else
		{
			wInDataOrg	= wInData;

			// o̓|[g̃f[^̓}XN
			wInData	&= pDoc->GetPIOMode();

			if(wDocData != wInData)
			{
				LogInputData(wDocData,wInDataOrg);
				pDoc->SetPIOInData(wInDataOrg);

				m_D0Btn.Invalidate();
				m_D1Btn.Invalidate();
				m_D2Btn.Invalidate();
				m_D3Btn.Invalidate();
				m_D4Btn.Invalidate();
				m_D5Btn.Invalidate();
				m_D6Btn.Invalidate();
				m_D7Btn.Invalidate();
				m_D8Btn.Invalidate();
				m_D9Btn.Invalidate();
				m_D10Btn.Invalidate();
				m_D11Btn.Invalidate();
				m_D12Btn.Invalidate();
				m_D13Btn.Invalidate();
			}
		}
	}

	CFormView::OnTimer(nIDEvent);
}

//***********************************************************************
//	֐FWindow Close
//	֐@FOnClose
//***********************************************************************
void CAXCPI01View::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	if(m_uTimer != 0)
	{
		KillTimer(m_uTimer);						//ϰI
		m_uTimer = 0;								//
	}

	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();

	if(m_bInit)
	{
		pApp->m_AxcpiLib.UtyAxcpi01Close();
	}

	CFormView::OnClose();
}

//***********************************************************************
//	֐Fo[W\
//	֐@FOnVerDriver
//***********************************************************************
void CAXCPI01View::OnVerDriver() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	DWORD			dwDllVersion	= 0;
	DWORD			dwDriverVersion	= 0;

	if(!pApp->m_AxcpiLib.UtyAxcpi01GetVersion(&dwDllVersion,&dwDriverVersion))
	{
		LogErrorMessage2();
	}

	CString	strMes1,strMes2,strMes3,strMes4;
		
	strMes1.Empty();
	strMes2.Empty();
	strMes3.Empty();
	strMes4.Empty();

	strMes1.LoadString(IDS_VERSION_INFO);
	strMes2.Format(TEXT(" Driver Version: %04XH"),dwDriverVersion);
	strMes3.Format(TEXT(" Dll Version: %04XH"),dwDllVersion);

	MakeLogList(strMes1,strMes2,strMes3,strMes4);
}

//***********************************************************************
//	֐F\[X\
//	֐@FOnVerResource
//***********************************************************************
void CAXCPI01View::OnVerResource() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CAXCPI01Doc* 	pDoc	= GetDocument();
	CAXCPI01App*	pApp	= (CAXCPI01App*)AfxGetApp();
	DWORD			dwIOPortBase	= 0;
	DWORD			dwIOPortLength	= 0;

	if(!pApp->m_AxcpiLib.UtyAxcpi01GetResource(&dwIOPortBase,&dwIOPortLength))
	{
		LogErrorMessage2();
	}
	CString	strMes1,strMes2,strMes3;
		
	strMes1.Empty();
	strMes2.Empty();
	strMes3.Empty();

	strMes1.LoadString(IDS_RESOURCE_INFO);
	strMes2.Format(TEXT(" I/O Address: %04XH - %04XH"),
					dwIOPortBase,(dwIOPortBase+dwIOPortLength-1));	//20030612 -1Ƃ

	MakeLogList(strMes1,strMes2,strMes3,strMes3);
}

//***********************************************************************
//	֐FWindow j
//	֐@FOnDestroy
//***********************************************************************
void CAXCPI01View::OnDestroy() 
{
	CFormView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	m_FontList.DeleteObject();			//̫ĵ޼ުĂ̔j
}
